-----------------------------------------------------------------------------

if not Aloft or not Aloft:HasModule("ShackleUndead") then return end
local AloftShackleUndead = Aloft:GetModule("ShackleUndead")

local L = AceLibrary("AceLocale-2.2"):new("AloftShackleUndeadOptions")
local SML = AceLibrary("SharedMedia-1.0")
local SML_statusbar = SML:List("statusbar")

-----------------------------------------------------------------------------

L:RegisterTranslations("enUS", function() return {
	["Shackle Undead"] = true,
	["Shackle Undead options"] = true,

	["Enable"] = true,
	["Shows shackle undead timers on nameplates when possible"] = true,
	["Speculative Attach"] = true,
	["Attempt to attach the shackle undead timer bar when it is not absolutely certain if it is the correct nameplate"] = true,
	["Texture"] = true,
	["Sets the shackle undead bar texture"] = true,
	["Colors"] = true,
	["Color options"] = true,
	["Bar Color"] = true,
	["Sets the shackle undead bar color"] = true,
	["Backdrop Color"] = true,
	["Sets the shackle undead backdrop color"] = true,
	["Size"] = true,
	["Shackle Undead size options"] = true,
	["Width"] = true,
	["Sets the width of the shackle undead bar"] = true,
	["Height"] = true,
	["Sets the height of the shackle undead bar"] = true,
	["Position"] = true,
	["Adjust shackle undead bar position"] = true,
	["Anchor"] = true,
	["Sets the anchor for the shackle undead bar"] = true,
	["Anchor To"] = true,
	["Sets the relative point on the health bar to anchor the shackle undead bar"] = true,
	["X Offset"] = true,
	["X offset of the shackle undead bar"] = true,
	["Y Offset"] = true,
	["Y offset of the shackle undead bar"] = true,
} end)

-----------------------------------------------------------------------------

Aloft.Options.args.shackleUndead =
{
	type = 'group',
	name = L["Shackle Undead"],
	desc = L["Shackle Undead options"],
	disabled = function() return not Aloft:IsActive() end,
	args =
	{
		enable =
		{
			type = 'toggle',
			name = L["Enable"],
			desc = L["Shows shackle undead timers on nameplates when possible"],
			get = function() return AloftShackleUndead.db.profile.enable end,
			set = function(v) AloftShackleUndead.db.profile.enable = v AloftShackleUndead:UpdateAll() end,
			order = 1
		},
		speculativeAttach =
		{
			type = 'toggle',
			name = L["Speculative Attach"],
			desc = L["Attempt to attach the shackle undead timer bar when it is not absolutely certain if it is the correct nameplate"],
			disabled = function() return not AloftShackleUndead.db.profile.enable end,
			get = function() return AloftShackleUndead.db.profile.speculativeAttach end,
			set = function(v) AloftShackleUndead.db.profile.speculativeAttach = v end,
			order = 2
		},
		texture =
		{
			type = "text", 
			name = L["Texture"], 
			desc = L["Sets the shackle undead bar texture"],
			disabled = function() return not AloftShackleUndead.db.profile.enable end,
			get = function() return AloftShackleUndead.db.profile.texture end,
			set = function(v) AloftShackleUndead.db.profile.texture = v AloftShackleUndead:UpdateAll() end,
			validate = SML_statusbar
		},
		colors =
		{
			type = 'group',
			name = L["Colors"],
			desc = L["Color options"],
			disabled = function() return not AloftShackleUndead.db.profile.enable end,
			args =
			{
				bar =
				{
					type = 'color',
					name = L["Bar Color"],
					desc = L["Sets the shackle undead bar color"],
					get = function() return unpack(AloftShackleUndead.db.profile.color) end,
					set = function(r, g, b, a) AloftShackleUndead.db.profile.color = { r, g, b, a } AloftShackleUndead:UpdateAll() end,
					hasAlpha = true,
					order = 1
				},
				backdrop =
				{
					type = 'color',
					name = L["Backdrop Color"],
					desc = L["Sets the shackle undead backdrop color"],
					get = function() return unpack(AloftShackleUndead.db.profile.backdropColor) end,
					set = function(r, g, b, a) AloftShackleUndead.db.profile.backdropColor = { r, g, b, a } AloftShackleUndead:UpdateAll() end,
					hasAlpha = true,
					order = 2
				},
			},
		},
		size =
		{
			type = 'group',
			name = L["Size"],
			desc = L["Shackle Undead size options"],
			disabled = function() return not AloftShackleUndead.db.profile.enable end,
			args =
			{
				width =
				{
					type = 'range',
					name = L["Width"],
					desc = L["Sets the width of the shackle undead bar"],
					min = 5,
					max = 250,
					step = 1,
					get = function() return AloftShackleUndead.db.profile.width end,
					set = function(v) AloftShackleUndead.db.profile.width = v AloftShackleUndead:UpdateAll() end
				},
				height =
				{
					type = 'range',
					name = L["Height"],
					desc = L["Sets the height of the shackle undead bar"],
					min = 2,
					max = 32,
					step = 1,
					get = function() return AloftShackleUndead.db.profile.height end,
					set = function(v) AloftShackleUndead.db.profile.height = v AloftShackleUndead:UpdateAll() end
				},
			},
		},
		position =
		{
			type = 'group',
			name = L["Position"],
			desc = L["Adjust shackle undead bar position"],
			disabled = function() return not AloftShackleUndead.db.profile.enable end,
			args =
			{
				anchor = {
					type = "text", 
					name = L["Anchor"], 
					desc = L["Sets the anchor for the shackle undead bar"],
					get = function() return AloftShackleUndead.db.profile.point end,
					set = function(v) AloftShackleUndead.db.profile.point = v AloftShackleUndead:UpdateAll() end,
					validate = {"TOPLEFT", "TOP", "TOPRIGHT", "LEFT", "CENTER", "RIGHT", "BOTTOMLEFT", "BOTTOM", "BOTTOMRIGHT"},
				},
				anchorto = {
					type = "text", 
					name = L["Anchor To"], 
					desc = L["Sets the relative point on the health bar to anchor the shackle undead bar"],
					get = function() return AloftShackleUndead.db.profile.relativeToPoint end,
					set = function(v) AloftShackleUndead.db.profile.relativeToPoint = v AloftShackleUndead:UpdateAll() end,
					validate = {"TOPLEFT", "TOP", "TOPRIGHT", "LEFT", "CENTER", "RIGHT", "BOTTOMLEFT", "BOTTOM", "BOTTOMRIGHT"},
				},
				offsetX =
				{
					type = 'range',
					name = L["X Offset"],
					desc = L["X offset of the shackle undead bar"],
					min = -32,
					max = 32,
					step = 1,
					get = function() return AloftShackleUndead.db.profile.offsetX end,
					set = function(v) AloftShackleUndead.db.profile.offsetX = v AloftShackleUndead:UpdateAll() end
				},
				offsetY =
				{
					type = 'range',
					name = L["Y Offset"],
					desc = L["Y offset of the shackle undead bar"],
					min = -32,
					max = 32,
					step = 1,
					get = function() return AloftShackleUndead.db.profile.offsetY end,
					set = function(v) AloftShackleUndead.db.profile.offsetY = v AloftShackleUndead:UpdateAll() end
				},
			},
		},
	},
}

-----------------------------------------------------------------------------
